<template>
  <div class="container-mid">
    <h3>Login</h3>
    <form>
      <div class="form-group">
        <label>Username</label>
        <input
          type="text"
          class="form-control"
          :value="user.username"
          @input="user.username = $event.target.value.toLowerCase()"
        />
      </div>
      <div class="form-group">
        <label>Password</label>
        <input :type="passwordInputType" class="form-control" v-model="user.password" />
      </div>
      <div class="d-flex">
        <button
          type="button"
          class="btn btn-outline-secondary mr-auto"
          @click="showPasswords = !showPasswords"
        >{{passwordShowHideText}}</button>
        <button class="btn btn-primary" type="submit" @click.prevent="submit">Submit</button>
      </div>
    </form>
    <app-feedback v-if="status" class="mt-5" @closed="status = ''">{{status}}</app-feedback>

    <app-ruler value="something" class="my-3">or</app-ruler>
    <button class="btn btn-outline-danger w-100">Login with Google</button>

    <div class="text-center text-muted mt-5">
      Don't have an account?
      <router-link to="/auth/register">Register now</router-link>.
    </div>
  </div>
</template>



<script>
export default {
  data() {
    return {
      status: "",
      showPasswords: false,
      user: {
        username: "",
        password: ""
      }
    };
  },
  computed: {
    passwordInputType() {
      return this.showPasswords ? "text" : "password";
    },
    passwordShowHideText() {
      return this.showPasswords ? "Hide password" : "Show password";
    }
  },
  methods: {
    async submit() {
      console.log("submitting");

      if (this.user.username == "") {
        this.status = "Username must not be empty.";
        return;
      }

      if (this.user.password == "") {
        this.status = "Password must not be empty.";
        return;
      }

      try {
        //await api.post("/auth/login", this.user);
        await this.$store.dispatch("auth/login", {
          url: "/auth/login",
          user: this.user
        });
        this.$router.push("/surveys");
      } catch (error) {
        switch (error.response.status) {
          case 401:
            this.status = error.response.data;
            break;
          case 404:
            this.status = error.response.data;
            break;
          default:
            this.status = `Unknown error :/`;
        }
      }
    }
  }
};
</script>